########################################################
# techinit.m for library altera
# Created by maketechinit - Fri Sep 24 12:46:46 PDT 1993

# Capacitance and technology types ###-> Fix to reflect actual values
Techdef.Syn_default_boundary = physical

Techdef.instance_properties = '()
# Optimization hooks ###-> Complete any as required
#Techdef.conndef = <func_name>
Techdef.idea_namefn = altera_fix_eddm_name
Techdef.libname = ALTERA_LIB
Techdef.format = binary
Techdef.ruledbs = '{ celldb }
Techdef.npcelllib = bin/cells.nplib
Techdef.prefix = "altera_"
Techdef.celldefs = '(bin/celldef.m)
Techdef.fromcelldefs = '(bin/fromcelldef.m)
Techdef.celllib = bin/celldef.ma
Techdef.fromcelllib = bin/fromcelldef.ma
Techdef.syn_design_properties = '{
}
Techdef.icons = icons/schem.icons
Techdef.genicons = icons/schemgen.icons
Techdef.Licons = icons/Lschem.icons
Techdef.Lgenicons = icons/Lschemgen.icons
Techdef.celllist = bin/celldef.list
Techdef.eddm_path = '("$MAX2_MFLIB" "$MAX2_GENLIB" "$MGC_GENLIB" "$MGC_LSLIB" )
Techdef.Syn_init = '{
    println "***  Altera  Library - Release 1.5 - May 1 1995"
    println "*** All rights reserved"
    pf bin/custom/patches/alt_loadpatches.m
}
Techdef.Syn_target_init = '{
}
Techdef.Np_init = '{
    pf bin/custom/initcode/npfunc.m
}
Techdef.autologic_init = '{
  load bin/custom/initcode/alt_checkfunc.m
}
Techdef.sgconfig = bin/custom/sgconfig

Techdef.route_tables = '{
    small {
        local {  # One small load/fanout
            table ()
            mult   0
            offset 0
        }
        module {
            table ()
            mult   0
            offset 0
        }
    }
}
Techdef.capsuffix = pf
Techdef.timesuffix = ns
Techdef.gatescale = 1000
Techdef.environment = '{
    Temperature {
        property temperature
        type     string
    }
    Voltage {
        property voltage
        type     string
    }
    "Process Corner" {
        property process
        type     radio_row
        choices  (Min Typ Max)
    }
    "Macrocell Instantiations" {
        property  vhdl_inst
        type     radio_row
        choices  (Yes No)
   }
    Technology {
        property fpga_tech
        type     radio_row
        choices  (MAX5000 MAX7000 FLEX8000)
    }
}
Techdef.Syn_derating = '{
    MAXfactor 1.4
    TYPfactor 1.0
    MINfactor 0.6
    TEMPref   25.0
    TEMPcoeff 0.004
    VOLTref   5.0
    VOLTcoeff 0.3
}
#Techdef.litweights = '( (AND 1))
Techdef.litweights = '( (AND 1) (XOR 5) )
Techdef.buffers = '("ALTERA_LIB:SOFT") 
Techdef.tbuffer = "ALTERA_LIB:SOFT"
Techdef.inverters = '("ALTERA_LIB:INV")
Techdef.pwr = '()
Techdef.gnd = '()
Techdef.rand3 = '( \
    "ALTERA_LIB:INV" "ALTERA_LIB:AND2" "ALTERA_LIB:NAND2" "ALTERA_LIB:OR2" \
    "ALTERA_LIB:NOR2" "ALTERA_LIB:AND3" "ALTERA_LIB:NAND3" "ALTERA_LIB:OR3" \
    "ALTERA_LIB:NOR3" "ALTERA_LIB:XOR2")
Techdef.rand4 = '( \
    "ALTERA_LIB:INV" "ALTERA_LIB:AND2" "ALTERA_LIB:NAND2" "ALTERA_LIB:OR2" \
    "ALTERA_LIB:NOR2" "ALTERA_LIB:AND3" "ALTERA_LIB:NAND3" "ALTERA_LIB:OR3" \
    "ALTERA_LIB:NOR3" "ALTERA_LIB:XOR2")
Techdef.rand5 = '("ALTERA_LIB:NAND2" "ALTERA_LIB:NOR2")
Techdef.rand6 = '("ALTERA_LIB:NAND2" "ALTERA_LIB:NOR2")
Techdef.tiecells = '( "COMB" "COMB2")
Techdef.Syn_default_constraints = '{
    cap          0.000000  # 2 loads
    maxload      20.000000  # 15 loads
    clockmaxload 0.000000  # 50 loads
    drive        (1.0 1.0)  # big nand drive
    clockdrive   (1.0 1.0)  # big inv drive
}
Techdef.custom_recipes = '{
 "Two Level Area Optimization" {
        func  alt_opt_area_twolevel
        scope all
 }
 "Write Edif Netlist" {
                func wr_altera_netlist
                scope top
                check_func altera_edif_name_check
                 args {
                        "EDIF File Name" {
                                type string
                                default "altera.edf"
                        }
                }

        }

 "MAX Specific Optimization" {
                func altera_opt_area_max
                scope all
                args {
                      "Netlist Size in gates ( <100 small, >100 large ) " {
                          type radio_row
                          choices (Large Small)
                          default Large 
                       }
                }
 }

}
Techdef.reports = '{
}
Techdef.Syn_default_env = '{
    temperature  25
    voltage       5
    process      Max
    vhdl_inst    No
    fpga_tech    MAX7000 
}
Techdef.maxcapnoroute = 0
